<template>
  <form @submit.prevent="$emit('submit')">
    <ModalBody>
      <div class="relative space-y-4">
        <transition :duration="100">
          <template v-if="isLoading">
            <div class="absolute z-10 flex h-full w-full rounded bg-white">
              <CircleNotchSolidIcon class="mx-auto my-10 h-7 w-7 animate-spin fill-primary-500" />
            </div>
          </template>
        </transition>
        <slot />
      </div>
    </ModalBody>
    <ModalFooter distributed>
      <slot name="footer" />
    </ModalFooter>
  </form>
</template>

<script setup lang="ts">
import CircleNotchSolidIcon from "@/svg/icons/circle-notch-solid.svg?component";
import ModalBody from "@/js/contexts/shared/ui/components/modal/ModalBody.vue";
import ModalFooter from "@/js/contexts/shared/ui/components/modal/ModalFooter.vue";

defineProps<{
  isLoading?: boolean;
}>();

defineEmits<{
  submit: [];
}>();
</script>
